define(['testsuite/qunit', 'jquery', 'ep/debug', '$dict!ep/dict-test', '$dict!ep/dict-test.en'], function (QUnit, $, ep, dict_de, dict_en) {

	QUnit.module("ep/dict");

	QUnit.test("ep/dict", function() {

		$.dictionary('my/dict1', [{'Other':'anderer'}]);
		$.dictionary('my/dict2', ['my/dict1', {'Back':'zurück'}]);
		$.dictionary('my/dict3', ['ep/dict-test', 'my/dict2', {'Hello':'Hallo'}]);

		var dict_de_1 = ep.dict('my/dict1', {region:'de'});
		var dict_de_2 = ep.dict('my/dict3', {region:'de'});
		var dict_de_3 = ep.dict('my/dict3', {region:'de'});

		QUnit.equal(
			dict_en.translate('Close'),
			'Close',
			"dict_en.translate('Close')"
		);

		QUnit.equal(
			dict_en.translate('New'),
			'New',
			"dict_en.translate('New')"
		);

		QUnit.equal(
			dict_en.translate('Error'),
			'Error',
			"dict_en.translate('Error')"
		);

		QUnit.equal(
			dict_de.translate('Close'),
			'Schließen',
			"dict_de.translate('Close')"
		);

		QUnit.equal(
			dict_de.translate('New'),
			'Neu',
			"dict_de.translate('New')"
		);

		QUnit.equal(
			dict_de.translate('Error'),
			'Fehler',
			"dict_de.translate('Error')"
		);

		QUnit.equal(
			dict_de_1.translate('Other'),
			'anderer',
			"dict_de_1.translate('Other')"
		);

		QUnit.equal(
			dict_de_2.translate('Other'),
			'anderer',
			"dict_de_2.translate('Other')"
		);

		QUnit.equal(
			dict_de_2.translate('Back'),
			'zurück',
			"dict_de_2.translate('Back')"
		);

		QUnit.equal(
			dict_de_3.translate('Close'),
			'Schließen',
			"dict_de_3.translate('Close')"
		);

		QUnit.equal(
			dict_de_3.translate('New'),
			'Neu',
			"dict_de_3.translate('New')"
		);

		QUnit.equal(
			dict_de_3.translate('Error'),
			'Fehler',
			"dict_de_3.translate('Error')"
		);

		QUnit.equal(
			dict_de_3.translate('Other'),
			'anderer',
			"dict_de_3.translate('Other')"
		);

		QUnit.equal(
			dict_de_3.translate('Hello'),
			'Hallo',
			"dict_de_3.translate('Hello')"
		);
	});

});